//	BBS

/*
	
	2003/07/05	̾32byteɽʤХ
	2003/10/26	εϤȥϥ󥰥åפХ
	2003/12/14	ХåեС󤹤ǽäΤǽ
	2004/03/24	к򾯤( write_check() )
	2004/09/18	å女ȥɲ(header_sendؿѹ)
*/



#define MAX_BBS_LINE	64
#define LINE_LENGTH		128
#define PRINT_BBS_LINE	32	//25
#define LIMIT_TIME	(60*5)	//ÿ
#define LIMIT_LINE	16		//Ϣ³񤭹¹Կ

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <errno.h>
#include <unistd.h>			//for access()
#include <fcntl.h> 			//for lockf
#include <sys/socket.h>		//for FreeBSD (LinuxϤ줬̵Ƥ⥳ѥ뤬̤)

#include "setting.h"	//Ƽdefine
#include "string_lib.h"

#include "InputFromForm.cpp"
static	InputFromForm	Form;

static	FILE *fd;

static	char	 common_buff[ LINE_LENGTH * 6 + 2 ];	//[256];
static	char sub_common_buff[ LINE_LENGTH * 6 + 2 ];	//HTML󥳡ѥХåե

static	char 	buff  [MAX_BBS_LINE][LINE_LENGTH];
static	char	name  [MAX_BBS_LINE][32];
static	char	target[MAX_BBS_LINE][32];
static	u_char	gazou [MAX_BBS_LINE];
static	time_t	w_time[MAX_BBS_LINE];



//åɤ߼
//GetCooKie

//̥
int GetCooKie_sub(const char* keyname, char register *tmp)
{
	register char *p;
	register int i=0;
	
	p = getenv( "HTTP_COOKIE" ); if(p==NULL) return 0;
	p = strstr(p,keyname) 	   ; if(p==NULL) return 0;
	p = strchr(p,'=');		   ; if(p==NULL) return 0;
	p++;
	while(p[i] && p[i]!=';' && i<32) { tmp[i]=p[i]; i++; }
	tmp[i]=0;
	return 1;
}


int GetCooKie_i(const char* keyname)
{
	if( GetCooKie_sub(keyname, common_buff) ==0) return 0;
	return atoi(common_buff);
}


//Ⱦѥʥå
int check_hankakukana(char *buff)
{
	u_char *str;
	
	str = (u_char*)buff;
	
	while(*str)
	{
		if( *str < 0x20 || (*str==0x8E && 0xA1<=*(str+1) && *(str+1)<=0xDF) )  	//Ⱦѥ
		//	|| (*str!=0x8F && *str>0x7E && *str<0xA0)				//JIS
		{
			return 1;
		}
		str++;
	}
	return 0;
	
	//å 1Х 	2Х 	3Х	ܸEUCξ 
	//G0 	 0x210x7E - 			-			ASCII 
	//G1 	 0xA00xFF 0xA00xFF 	- 			JIS X 0208-1990ʿJIS 
	//G2 	 0x8E 		0xA00xFF 	- 			JIS X 0201ʡ1ХȲ̾ 
	//G3 	 0x8F 		0xA00xFF 	0xA00xFF	JIS X 0212-1990 
}


/*
void bbs_init(void)
{
	for(int i=0; i<MAX_BBS_LINE ; i++) buff[i][0] = 0;
	//memset(buff, 	0, sizeof(buff) );
	//memset(name, 	0, sizeof(name) );
	//memset(gazou, 	0, sizeof(gazou) );
	//memset(w_time,	0, sizeof(w_time) );
}
*/

void save()
{
	//write
	fseek(fd,0,SEEK_SET);
	fwrite(buff, 	sizeof(buff),	1,fd);
	fwrite(name,	sizeof(name),	1,fd);
	fwrite(target,	sizeof(target),	1,fd);
	fwrite(gazou,	sizeof(gazou),	1,fd);
	fwrite(w_time,	sizeof(w_time),	1,fd);
}

inline int bbs_open(int room)
//֤ 1:0:
{
	int flag = 1;
	
	sprintf(common_buff, "room%04u/bbs_log.cgi",room);	//ե͡
	fd = fopen(common_buff, "r+");
	
	if(fd==NULL)
	{
		if(access(common_buff,F_OK)== -1)	//ե뤬¸ߤʤ 
		{
			fd = fopen(common_buff, "wb" );
			for(int i=0; i<MAX_BBS_LINE ; i++)
			{
				//ǡꥢ
				*buff[i] = 0;
				*name[i] = 0;
				*target[i] = 0;
				gazou[i] = 0;
				w_time[i] = 0;
			}
			
			w_time[0] = time(NULL);	//å女ȥΤᡢե֤
			
			save();
			
			flag=0;
		}
		else
		{
			puts("bbs file error");
			exit(1);
		}
	}
		
	if( lockf(fileno(fd), F_LOCK , 0) == -1 )
	{
		puts("ǼĤϺߤäƤޤ / file busy"); 
		exit(1);
	}
	
	return flag;
}

inline void bbs_close(void)
{
	fclose(fd);
}

inline void file_2_buff(void)
{
	fseek(fd,0,SEEK_SET);
	fread( buff,	sizeof(buff),	1,fd);
	fread( name,	sizeof(name),	1,fd);
	fread( target,	sizeof(target),	1,fd);
	fread( gazou,	sizeof(gazou),	1,fd);
	fread( w_time,	sizeof(w_time),	1,fd);
}



//ǽȯ
inline time_t get_last_modified()
{
	if( w_time[0] && time(NULL) >= w_time[0] ) return w_time[0]; else return time(NULL);
}


inline int write(int room, const char *mess, const char *u_name, int u_gazou, const char *target_f)
{
	if( bbs_open(room) ) file_2_buff();
	
	//ΤΥХåեĸˤ餷
	memmove( buff[1], 		buff[0], 	LINE_LENGTH 		* (MAX_BBS_LINE-1) );
	memmove( name[1], 		name[0], 	32					* (MAX_BBS_LINE-1) );
	memmove( target[1],	  target[0],	32					* (MAX_BBS_LINE-1) );
	memmove( &gazou[1],	  &gazou[0],	sizeof(gazou[0])	* (MAX_BBS_LINE-1) );
	memmove( &w_time[1], &w_time[0],	sizeof(w_time[0])	* (MAX_BBS_LINE-1) );
		
	//Ƭ
	strncpy(buff[0], mess,		LINE_LENGTH);
	strncpy(name[0], u_name,	32);
	
	if(target_f == NULL || strcmp2(target_f,"0")==0) target[0][0] = 0;
	else strncpy(target[0], target_f, 32);
	
	gazou[0]  = u_gazou;
	w_time[0] = time(NULL);
	
	/*
	//write
	fseek(fd,0,SEEK_SET);
	fwrite(buff, 	sizeof(buff),	1,fd);
	fwrite(name,	sizeof(name),	1,fd);
	fwrite(target,	sizeof(target),	1,fd);
	fwrite(gazou,	sizeof(gazou),	1,fd);
	fwrite(w_time,	sizeof(w_time),	1,fd);
	*/
	
	save();
}

//񤭹ߤ̵Υå
void no_message(void)
{
	puts(	"<tr><td>ԷǼĤǤͳ˻ȤäƤ</td></tr>");
}


//ɽᥤ
inline void print_bbs(int user, const char *u_name)
{
	if(u_name==NULL) u_name = "";
	
	puts("<table class=\"s1\" border=\"0\">");
	
	if( *buff[0] ==0 )	//񤭹ߤ̵
	{
		no_message();
		puts("</table>" );
		return;
	}
	
	int PrintCount = 0;
	
	for(int i=0; (i<MAX_BBS_LINE && PrintCount < PRINT_BBS_LINE) ; i++)
	{
		bool SecretMode;
		
		if( *buff[i] )
		{
			/*
			if( target[i]>MAX_PLAYER ) //ʳ
			{
				if( user && int(target[i])-MAX_PLAYER != user ) flag=1;
			}
			*/
			
			if(target[i][0])	//
			{
				if( strncmp2(target[i], u_name,32) && strncmp2( name[i], u_name,32)) {
					//褬ɤǤ̵ͤ
					continue;
				}
				else SecretMode = 1;
			}
			else SecretMode = 0;
							
			//
			puts("<tr valign=\"top\">");
			printf(	"<td width=\"%d\">"
					"<img src=\"" GIF_DIR "%02u.gif\" width=\"%d\" height=\"%d\">"
					"</td>"
					,(MX_SIZE/2)+8,	gazou[i], MX_SIZE/2 ,MY_SIZE/2
			);
			
			//̾
			if(gazou[i])
			{
				printf("<td nowrap>%.32s</td><td>:</td>",name[i]);//̥桼
			}
			else
			{
				printf( "<td nowrap><font color=\"#FF0000\">%.32s</font>"
						"</td><td>:</td>" , name[i]);	//
			}
			
			//ʸ
			printf("<td>");
			
			//̩
			if(SecretMode)
			{
				printf("<font color=\"#FF0000\">to: %.32s</font>"
						,target[i] );
			}
			
			strncpy( sub_common_buff , buff[i], 128);
			html_encord( sub_common_buff , common_buff);
			
			puts( common_buff );	//å		
			
			puts("</td>");	//<td width=\"8\"></td>
			
			//"%Y/%m/%d(%a) %H:%M"
			strftime(common_buff,25,"%m/%d %H:%M",localtime(&w_time[i]) );
	 		printf("<td nowrap> (%s)</td>",common_buff);
			
			puts( "</tr>");
			
			PrintCount++;
		}
	}
	
	if(PrintCount==0) no_message();
	puts("</table>");
}

void header_send( time_t last_modified )
{
	//#define BG	"#F3F2D6"
	#define BG	"#FFFFFF"
	#define FG	"#DCC49A"
	
	//å女ȥ
	char date_str_buff[48];
    struct tm *t_st;
    
    //ǽ
    if( last_modified == 0 ) last_modified = time(NULL);
        
    t_st = gmtime(&last_modified);
    strftime( date_str_buff, 48, "Last-Modified: %a, %d %b %Y %X GMT\n", t_st );   //ex. "Last-Modified: 26 Jul 1997 05:00:00 GMT";
    
    printf(date_str_buff);
    
    printf( "Cache-Control: private\n");
    printf( "Content-type: text/html\n\n" );
	
	puts(	"<html>\n"
			"<head>\n"
			"<title>BBS</title>\n"	
			"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\n"
		
	 		"<style type=\"text/css\">\n"
	 		"<!--\n"
			".s1 {  font-size: 18px; font-weight: normal; color: #404040}\n"
			//".s2 {  font-size: 18px; font-weight: bold; color: #000000}\n"
			
			"body {scrollbar-highlight-color:" FG ";\n"
			"scrollbar-arrow-color:" FG ";\n"
			"scrollbar-shadow-color:" FG ";\n"
			"scrollbar-face-color:" BG ";\n"
			"scrollbar-3dlight-color:" BG ";\n"
			"scrollbar-darkshadow-color:" BG ";\n"
			"scrollbar-track-color:" BG ";}\n"
		
			"-->\n"
			"</style>\n"
			"</head>\n"
			"<body bgcolor=\"" BG "\" text=\"#000000\">\n"
	);
}



void span1(void)
{
	puts("<span class=\"s1\"><font color=\"#FF0000\"><b>");
}
void span2(void)
{
	puts("</b></font></span><p>" );
}


int write_check(int user,int mes_length,char *mes,int u_gazou,char *u_name, char *target_f)
{
	if(user==0)
	{
		span1();
		puts("󤷤ʤȽ񤭹ߤǤޤ");
		span2();
		return 0;
	}
	
	//add 2004.03.24
	int len = strlen(u_name);
	if( (user < 1000 && u_gazou == 0) 
		|| len==0 || len >32 
		|| u_gazou < 0 || u_gazou>255 
		|| strlen(target_f) > 32 )
	{
		span1();
		puts("send data error");
		span2();
		return 0;
	}
	
		
	if( check_hankakukana(mes) )
	{
		span1();
		puts( "åȾѥʡ楳ϻȤޤ");
		span2();
		return 0;
	}
	
	if(mes_length>126)
	{
		span1();
		puts( "åѤ63ʸޤǤǤ");
		span2();
		return 0;
	}
	
	if(gazou[0]==u_gazou && strcmp2(mes,buff[0])==0 && strncmp2(target_f, target[0],32)==0)
	{
		span1();
		puts( "ƤǤ");
		span2();
		return 0;
	}
	
	
	time_t now;
	now = time(NULL);
	if(w_time[0] + LIMIT_TIME > now)
	{
		int i=0;
		while(i<LIMIT_LINE && user<1000 && gazou[i]==u_gazou) i++;
		if(i==LIMIT_LINE)
		{
			span1();
			puts("Ϣ³񤭹ߤ϶ػߤǤ");
			span2();
			return 0;
		}
	}
		
	return 1;
}

	
int main(void)
{
	char *mes , *u_name, *target_f;
	
	int  uid_form_cookie = 0;
	int  uid_from_form   = 0;
	int  u_gazou         = 0;
	int  user            = 0;
	int  mes_length      = 0;
	int  room            = 0;
	int  crc_from_form   = 0;
	
	setenv("TZ" , TIMEZONE , 1);	//糧å
				
	room = Form.getform_i("room");
	
	if(room<1 || MAX_ROOM < room )
	{
		header_send( time(NULL) );
		printf("%d\n<br>",room);
		puts("error (ROOM No.)");
		exit(1);
	}
	
	mes  = Form.getform_c("message");
		
	if(mes == NULL) mes_length = 0;
	else            mes_length = strlen(mes);
	
		
	//եɤ߹
	if( bbs_open(room) ) file_2_buff();
	
	//إå
	if(mes_length) header_send(time(NULL)); else header_send( get_last_modified() );
	
		
	uid_from_form = Form.getform_i("user");
	target_f      = Form.getform_c("target");
	
	if( uid_from_form >= 1000 )	//ͽ񤭹߻
	{
		uid_form_cookie = GetCooKie_i("admin_id");
		u_gazou  = 0;
		u_name	 = "";
	}
	else
	{
		//user
		if(uid_from_form)
		{
			uid_form_cookie = GetCooKie_i("user");	
			u_gazou         = Form.getform_i("u_gazou");
			u_name	        = Form.getform_c("u_name");
			crc_from_form   = Form.getform_i("crc");
			
			if( u_name == NULL || strlen(u_name)  > 256 )
			{
				puts("ERROR / ѥ᡼");
				exit(1);
			}
			
			if( !crc_from_form )
			{
				puts("ERROR / formΥѥ᡼'crc'ޤ");
				puts("v1.2.xupdate_view.html⹹Ƥ"); 
				exit(1);
			}
			
			int po  = 0;
			int crc = 0;
				
			while( u_name[po] && po<=32)
			{
				crc += (48 - po) * u_name[po]; 
				po++;
			}
			crc ^= ( room | (uid_from_form<<5) | (u_gazou<<10) ) ;
			crc = crc & 0xffff;
			
			if( crc != crc_from_form || u_name==NULL)
			{
				uid_form_cookie = 0;
		    	u_gazou         = 0;        
		    	u_name = "guest";
		   	}
		}
		else
		{
			u_name = "guest";
		}
	}
	
	if( uid_from_form && uid_form_cookie == uid_from_form )
	{
		user = uid_from_form;
	}
	else
	{
		user = 0;
	}
	
	
	if(mes_length)
	{
		//񤭹
		if( write_check(user, mes_length, mes, u_gazou, u_name, target_f) )
		{
			write(room, mes, u_name, u_gazou, target_f);
		}
	}
				
	print_bbs(user, u_name);
	bbs_close();
	
	puts(	"</body></html>");
}

