#ifndef FLAG_ACCESS
#include "flag_accesse.cpp"
#endif



//=============================== gamedata ================================

enum
{
	G_STATUS_NORMAL = 0,			//
	G_STATUS_NOT_START,				//ཪλ塢ƥȤϤʤ
	G_STATUS_GAMEOVER,				//ཪλ塢ȥ꡼
	G_STATUS_RECEPT_ENTRY,			//ȥ꡼
};	


//gamedata
//212byte	
struct gamedata {
	
	double	price_food,  price_fighter,  price_mage,  price_monster;	//
	int 	TotalSellFood,	TotalBuyFood;
	u_int	TotalPeople;
	
	//--ͽ
	int		yobi1,	yobi2;
	u_int	yobi3;
	
	int global_foods_stock;
	
	//ִط
	time_t	turn_time,	last_time,	start_time,		end_time;
	time_t	nextgame,	next_start,	last_turn_time, waiting_period;
	
	short	HtmlFileId;
	short	turn_count;
	u_short	UnitSerialNnumber;	//˥åȤΥꥢʥС
	u_int	authentication_key;	//ǧڥ
	
	short 	yobi_s_1;
	short	OldBattleTurn;		//ָŤƮΥ
	
	u_short	yobi_s_3, yobi_s_4;
	
	
	char 	hp[64];
	char	DeleteNoAccessTurn;
	
	char	yobi_c_1;
	
	char 	data_format_version;
		
	char status;
	char ninzuu;		//ߤλüԿ
	char plimit;		//üԿͿ
		
	//ƥब˽и
	u_char ItemAppearance[32];	// ( sizeof Item/sizeof Item[0] )/8 +1 ] = 21 ¿32;
	
	char admin_pass[16];
	
	//ե饰
	struct {
		unsigned char	NoVacancy	: 1;	//
		unsigned char	regist_user	: 1;	//쥸Ȥ
   		unsigned char	enemy_mode	: 1;	//ŨCPU ON
		unsigned char	DennySameIp	: 1;	//ƱIPΥԵ
		unsigned char	show_ip		: 1;	//ƱIP桼ξɽ뤫
		unsigned char	TheefComing	: 1;	//±BOSSо줷
		unsigned char	enter_hero1 : 1;
		unsigned char	flag8		: 1;
	} flag;
	
	u_char	yobi_c_3;
	u_char	EnemyActionCount;	//ΥŨ(cpu)ư
	
				
	//೫ν
	void init(void)
	{
		data_format_version = DATAFILE_VIRSION;	//v1.3
		
		ninzuu = 0;
		price_food = DEFAULT_PRICE_FOOD;
		price_fighter = price_mage = price_monster = 1.00;
		TotalSellFood = TotalBuyFood = 0;
		TotalPeople = 0;
		
		//long int TotalTradeOfFood = 0;
		HtmlFileId = 0;
		turn_count = 0;
		UnitSerialNnumber = 0;
		
		global_foods_stock = DEFAULT_FOODS_STOCK;
		
		
		//ͽ
		yobi1 = yobi2	 = yobi3 = 0;
		yobi_s_1 = yobi_s_3 = yobi_s_4 = 0;
		yobi_c_1 = yobi_c_3 = 0;
		EnemyActionCount = 0;
		OldBattleTurn=1;
		
						
		//ƥиɤե饰
		for(int i=0; i<(sizeof ItemAppearance/sizeof ItemAppearance[0]) ; i++) {
			ItemAppearance[i]=0;
		}
		ItemAppearance[0] = 0x01;
		
		//ե饰
		#ifdef FORCE_SHOW_SAME_IP
		flag.show_ip = 1;
		#endif
		
		flag.NoVacancy = 0;
		flag.TheefComing = 0;
		flag.enter_hero1 = 0;
		flag.flag8 = 0;
	}
		
	gamedata()	//ǡν
	{
		DeleteNoAccessTurn = 0;
		
		flag.regist_user = 0;
		flag.enemy_mode =  0;
		flag.DennySameIp = 0;
		flag.show_ip	 = 0;
		
		authentication_key = 0;
		
		turn_time = last_time = last_turn_time = waiting_period = 0;
		plimit = MAX_PLAYER;
		status = G_STATUS_RECEPT_ENTRY;
		
		init();
	}
	
	void start()
	{
		status = G_STATUS_NORMAL;
	
		global_foods_stock = DEFAULT_FOODS_STOCK + DEFAULT_FOODS_STOCK2 * ninzuu;
		
		if( flag.enemy_mode) global_foods_stock += DEFAULT_FOODS_STOCK2 * 6;
	}
	
	
	//
	int  item(int n);				
	void item(int n, int value);
	void HtmlFileIdCheck(void);
	void add_foods_stock(int value);
};

static	gamedata		gdata;

int gamedata::item(int n)
{
	return FlagRead(ItemAppearance , n);
}

void gamedata::item(int n, int value)
{
	FlagWrite(ItemAppearance, n, value);
}

void gamedata::HtmlFileIdCheck(void)
{
	HtmlFileId++;
	
	if(HtmlFileId > BATTLE_LOG_MAX || (HtmlFileId >32 && OldBattleTurn+16 < turn_count) )
	{
		HtmlFileId = 0;
		OldBattleTurn = turn_count;
	}
}


void gamedata::add_foods_stock(int value)	//add v1.3 2004.06.20
{
	global_foods_stock += value;
	
	     if(global_foods_stock < 0              ) global_foods_stock = 0;
	else if(global_foods_stock > MAX_FOODS_STOCK) global_foods_stock = MAX_FOODS_STOCK;
}

