#ifndef STRING_LIB
#define STRING_LIB

void TrimLeft(char *str)
{
	int i;
	
	if( str[0] == '\0' ) return;
	
	if( str[0] == ' ' )
	{
		i = 0;
		while( str[i+1] != 0)
		{
			str[i] = str[i+1];
			i =i + 1;
		}
		
		str[i] = '\0';
		
		TrimLeft(str);	//ƵƤӽФ
	}
}

void TrimRight(char *str)
{
	int len;
	
	if( str[0] == '\0' ) return;
	
	len = strlen(str)-1;
	
	if( str[len] == ' ' )
	{
		str[len] = '\0';
		
		TrimRight(str);	//ƵƤӽФ
	}
}

void trim(char *str)
{
	TrimLeft(str);
	TrimRight(str);
}



void replace(char* str, const char* find,  const char *replace_str)
{
	char *p;
	char *p_src;
	
	char *new_buff;
	new_buff = new char[ strlen(str) * 6 + 2] ;
	
	p_src = str;
	new_buff[0] = '\0';
	
	while ( (p = strstr(p_src, find)) != NULL )
	{
		*p = '\0';
		strcat( new_buff, p_src);
		strcat( new_buff, replace_str );
		p_src = (p+1);
	}
	
	strcat( new_buff, p_src);
	
	strcpy( str, new_buff);
	delete new_buff;
}


void html_encord(const char *str, char *ret_buff)
{
	strcpy( ret_buff, str);
	trim(ret_buff);
	
	replace(ret_buff, "&"  , "&amp;");
	replace(ret_buff, " "  , "&nbsp;");
	replace(ret_buff, "<"  , "&lt;");
	replace(ret_buff, ">"  , "&gt;");
	replace(ret_buff, "\"" , "&quot;");
}


#endif
